# Generic panel coordination
# One process coordinates operations within the tree, so that
# there are no races.
Wtree: module {
	PATH: con "/dis/o/live/wtree.dis";

	# to implement tree. internal use only.
	Treeop: adt {
		rc:	chan of ref Wpanel->Panel;
		path:	string;
		pick {
		Walk or Dump or Close or Tags or Focus =>
		Update =>
			vers:	int;
			ctls:	string;
			data:	array of byte;
			edits:	string;
		Layout =>
			auto:	int;
		Size =>
			op:	int;	# More, Full, Max
		Ptwalk =>
			pt:	Draw->Point;
			atomok:	int;
		Mouse =>
			m:	ref Gui->Cpointer;
			mc:	chan of ref Gui->Cpointer;
		Kbd =>
			r:	int;
		}
	};

	More, Max, Full: con iota;	# for Tree.size and Treeop.Size.to

	Tree: adt {
		root:	string;			# path in o/mero for our /
		slash:	ref Wpanel->Panel;		# "/" for the entire tree
		dslash:	ref Wpanel->Panel;		# "/" for the shown portion
		opc:	chan of ref Treeop;		# internal use only
		donec:	chan of ref Wpanel->Panel;	# panel no longer busy
		focus:	ref Wpanel->Panel;

		start:	fn(name: string): ref Tree;
		terminate:	fn(t: self ref Tree);

		path:	fn(t: self ref Tree, p: ref Wpanel->Panel): string;
		walk:	fn(t: self ref Tree, path: string): ref Wpanel->Panel;
		ptwalk:	fn(t: self ref Tree, xy: Draw->Point, atomok: int): ref Wpanel->Panel;
		mouse:	fn(t: self ref Tree, m: ref Gui->Cpointer,
				mc: chan of ref Gui->Cpointer): ref Wpanel->Panel;
		kbd:	fn(t: self ref Tree, r: int): ref Wpanel->Panel;
		update:	fn(t: self ref Tree, path: string, vers: int,
				ctls: string, data: array of byte, edits: string);
		close:	fn(t: self ref Tree, path: string);
		size:	fn(t: self ref Tree, path: string, op: int);
		layout:	fn(t: self ref Tree, path: string, auto: int);
		tags:	fn(t: self ref Tree, path: string);
		dump:	fn(t: self ref Tree, path: string);
	};

	init:		fn(d: Livedat);
	panelmouse:	fn(t: ref Tree, p: ref Wpanel->Panel,
				m: ref Gui->Cpointer, cm: chan of ref Gui->Cpointer): int;
	panelkbd:		fn(t: ref Tree, p: ref Wpanel->Panel, k: int);
	tagmouse:	fn(t: ref Tree, p: ref Wpanel->Panel,
				m: ref Gui->Cpointer, mc: chan of ref Gui->Cpointer);
	panelctl:		fn(t: ref Tree, p: ref Wpanel->Panel, s: string): int;
};
