# The glue merging panels and files.
# This provides an interface for handling panels that maintains and
# adjusts the file tree according to the panels.
# Not a real module, just operations on panels and their trees.

Merotree: module {

	PATH: con "/dis/o/mero/merotree.dis";

	init:		fn(d: Dat): chan of ref Styxservers->Navop;
	pwalk:		fn(s: string): (ref Panels->Panel, ref Panels->Repl);
	pcreate:		fn(dp: ref Panels->Panel, dr: ref Panels->Repl,
				name: string): ref Panels->Panel;
	premove:	fn(p: ref Panels->Panel, rr: ref Panels->Repl);
	pchanged:	fn(p: ref Panels->Panel, data: int, ctl: int, olivetoo: int);
	pheldupd:	fn(p: ref Panels->Panel, vers: int);
	pchanges:	fn(p: ref Panels->Panel, r: ref Panels->Repl,
			vers: int): (list of ref Merop->Msg, int);
	moveto:		fn(p: ref Panels->Panel, r: ref Panels->Repl,
				path: string, pos: int): string;
	copyto:		fn(p: ref Panels->Panel, r: ref Panels->Repl,
				path: string, pos: int): string;
	chpos:		fn(p: ref Panels->Panel, r: ref Panels->Repl, pos: int);
	mkcol:		fn(p: ref Panels->Panel, r: ref Panels->Repl);
	mktree:		fn();
	dump:		fn();
};
